#_______
# BIOMOD complementary functions
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Ens.Forecasting <- function(Proj.name,Espece,data.Modl,data.Proj,Time){

   dir.create(paste(getwd(),"/cons.",Time,sep = ""),showWarnings = F)

   # Manipulation des objets "Projections"
   if (Time == "Current"){
      load(paste(getwd(),"/proj.Current/Proj_Current_",Espece,sep = ""))
      Proj <- eval(parse(text = paste("Proj_Current_",Espece,sep = "")))
      
   }else{
      load(paste(getwd(),"/proj.",Proj.name[1],"/Proj_",Proj.name[1],"_",Espece,sep = ""))
      Proj <- eval(parse(text = paste("Proj_",Proj.name[1],"_",Espece,sep = "")))
      List <- list()
      for (j in 1 : dim(Proj)[2]){
         List[[j]] <- Proj[,j,2:dim(Proj)[3],1]
         names(List)[j] <- dimnames(Proj)[[2]][j]
      }
      if (length(Proj.name) > 1){
         for (i in 2 : length(Proj.name)){
            load(paste(getwd(),"/proj.",Proj.name[i],"/Proj_",Proj.name[i],"_",Espece,sep = ""))
            Proj <- eval(parse(text = paste("Proj_",Proj.name[i],"_",Espece,sep = "")))
            for (j in 1 : dim(Proj)[2]){
               List[[j]] <- as.data.frame(cbind(List[[j]],Proj[,j,2:dim(Proj)[3],1]))
            }
         }
      }
      Proj <- list()
      j <- 0
      for (i in 1 : length(List)){
         if (!is.na(List[[i]][1,1])){
            j <- j + 1
            Proj[[j]] <- List[[i]]
            names(Proj)[j] <- names(List)[i]
         }
      }
   }

   # Calcul des poids
   load(paste(getwd(),"/",Espece,"_run.Rdata",sep = ""))
   Imp <- VarImportance[[1]]
   Eval <- Evaluation.results.Roc[-1]
   auc <- data.frame()
   for (i in 1 : length(Eval)){
         auc <- as.data.frame(rbind(auc,t(as.numeric(Eval[[i]][,1]))))
   }
   colnames(auc) <- rownames(Eval[[1]])

   auc.w <- as.data.frame(matrix(NA,nrow = dim(auc)[1],ncol = dim(auc)[2]))
   colnames(auc.w) <- colnames(auc)
   for (i in 1 : dim(auc)[2]){
      auc.w[,i] <- auc[,i]/sum(auc[,i])
   }

   # Initialisation des matrices
   if (Time == "Current"){
      Cons <- matrix(nrow = dim(Proj)[1],ncol = dim(auc)[2]+1) ; colnames(Cons) = c(colnames(auc),"Total")
      Sd <- matrix(nrow = dim(Proj)[1],ncol = dim(auc)[2]+1) ; colnames(Sd) = c(colnames(auc),"Total")
      Cons_Bin <- matrix(nrow = dim(Proj)[1],ncol = dim(auc)[2]+1) ; colnames(Cons_Bin) = c(colnames(auc),"Total")
      CutOff = matrix(nrow = 1,ncol = dim(auc)[2]+1) ; colnames(CutOff) = c(colnames(auc),"Total")
   }else{
      Cons <- matrix(nrow = dim(Proj[[1]])[1],ncol = dim(auc)[2]+1) ; colnames(Cons) = c(colnames(auc),"Total")
      Sd <- matrix(nrow = dim(Proj[[1]])[1],ncol = dim(auc)[2]+1) ; colnames(Sd) = c(colnames(auc),"Total")
      Cons_Bin <- matrix(nrow = dim(Proj[[1]])[1],ncol = dim(auc)[2]+1) ; colnames(Cons_Bin) = c(colnames(auc),"Total")
      CutOff <- read.table(paste(getwd(),"/cons.Current/CutOff_",Espece,".txt",sep=""),h = T)
   }

   for (i in 1 : dim(auc)[2]){

      # Calcul des projections consensuelles pondres
      temp <- NULL
      if (Time == "Current"){
         for (j in 2 : dim(Proj)[3]){
            temp <- cbind(temp,Proj[,colnames(auc)[i],j,]*auc.w[j-1,i])
         }
      }else{
         auc.sdm <- rep(auc[,names(Proj)[i]],((dim(Proj[[i]])[2])/(dim(auc)[1])))
         auc.sdm <- auc.sdm/sum(auc.sdm)
         for (j in 1 : dim(Proj[[i]])[2]){
            temp <- cbind(temp,Proj[[i]][,j]*auc.sdm[j])
         }
      }
      Cons[,i] <- round(apply(temp,1,sum))

      # Transformation en donnes binaires
      if (Time == "Current"){
      
         Merge <- merge(data.Proj,data.Modl,all.x = T,all.y = T,by.x = "Grid_IDKey",by.y = "Grid_IDKey")
         pos <- which(!is.na(Merge[,3]))
         temp <- round(CutOff.Optimised(data.Modl[,Espece],Cons[pos,i]))
         CutOff[1,i] = temp[1]
      }
      Cons_Bin[,i] <- BinaryTransformation(Cons[,i],CutOff[1,i])

      # Calcul des cart-types par SDM
      temp <- NULL
      if (Time == "Current"){
         for (j in 2 : dim(Proj)[3]){
            temp <- cbind(temp,(auc.w[j-1,i]*((Proj[,colnames(auc)[i],j,]-Cons[,i])^2)))
         }
      }else{
         for (j in 1 : dim(Proj[[i]])[2]){
            temp <- cbind(temp,(auc.sdm[j]*((Proj[[i]][,j]-Cons[,i])^2)))
         }
      }
      Sd[,i] <- round(sqrt(apply(temp,1,sum)))
   }

   # Calcul des poids (consensus total)
   if (Time == "Current"){
      tab <- rep(NA,dim(Proj)[1]) ; AUC = c()
      for (i in 1 : dim(auc)[2]){
         tab <- as.data.frame(cbind(tab,Proj[,colnames(auc)[i],-1,]))
         AUC <- c(AUC,auc[,i])
      }
   }else{
      tab <- rep(NA,dim(Proj[[1]])[1]) ; AUC = c()
      for (i in 1 : dim(auc)[2]){
         tab <- (cbind(tab,Proj[[i]]))
         AUC <- c(AUC,rep(auc[,i],((dim(Proj[[i]])[2])/(dim(auc)[1]))))
      }
   }
   tab <- tab[,-1]
   Auc.sum <- sum(AUC)

   # Calcul des projections consensuelles pondres (consensus total)
   tempP <- NULL
   for (j in 1 : length(AUC)){
         tempP <- cbind(tempP,tab[,j]*(AUC[j]/Auc.sum))
   }
   Cons[,(dim(auc)[2]+1)] <- round(apply(tempP,1,sum))

   # Transformation en donnes binaires (consensus total)
   if (Time == "Current"){

      Merge <- merge(data.Proj,data.Modl,all.x = T,all.y = T,by.x = "Grid_IDKey",by.y = "Grid_IDKey")
      pos <- which(!is.na(Merge[,3]))
      temp <- round(CutOff.Optimised(data.Modl[,Espece],Cons[pos,(dim(auc)[2]+1)]))
      CutOff[1,(dim(auc)[2]+1)] = temp[1]
   }
   Cons_Bin[,(dim(auc)[2]+1)] <- BinaryTransformation(Cons[,(dim(auc)[2]+1)],CutOff[1,(dim(auc)[2]+1)])

   # Calcul des cart-types par SDM (consensus total)
   tempS <- NULL
   for (j in 1 : dim(tab)[2]){
      tempS <- cbind(tempS,((AUC[j]/Auc.sum)*((tab[,j]-Cons[,(dim(auc)[2]+1)])^2)))
   }
   Sd[,(dim(auc)[2]+1)] <- round(sqrt(apply(tempS,1,sum)))

   # Calcul de l'importance moyenne des variables
   if (Time == "Current"){
      Auc <- Evaluation.results.Roc[1]
      vec <- Imp
      for (i in 1 : dim(Imp)[1]){
         vec[i,] <- round((Imp[i,]*as.numeric(as.character(Auc[[1]][i,"Cross.validation"])))/
                                   sum(as.numeric(as.character(Auc[[1]][,"Cross.validation"]))),3)
      }
      temp <- apply(vec,2,sum)
      Var <- as.data.frame(rbind(Imp,temp))
      Model <- c(rownames(Imp),"Total")
      Var <- as.data.frame(cbind(Model,Var))
      colnames(Var) <- c("Model",colnames(Imp))
      rownames(Var) <- NULL
   }

   write.table(Cons,file = paste(getwd(),"/cons.",Time,"/Cons_Proj_",Time,"_",Espece,".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
   write.table(Sd,file = paste(getwd(),"/cons.",Time,"/Sd_Proj_",Time,"_",Espece,".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
   write.table(Cons_Bin,file = paste(getwd(),"/cons.",Time,"/Cons_Proj_",Time,"_",Espece,"_Bin.txt",sep = ""),col.names = T,row.names = F,sep = "\t")
   if (Time == "Current"){
      write.table(CutOff,file = paste(getwd(),"/cons.",Time,"/CutOff_",Espece,".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
      write.table(Var,file = paste(getwd(),"/cons.",Time,"/VarImp_",Espece,".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
   }

   colnames(tab) = seq(1,dim(tab)[2],1)
   library(ade4)
   acp = dudi.pca(tab,scan = F)
   Perc = round((acp$eig[1]/sum(acp$eig))*100,2)

   cat("---------------------------------------","\n")
   cat(paste("   ","Species:                  ",Espece,sep = ""),"\n")
   cat("---------------------------------------","\n")
   cat(paste("   ","Time:                     ",Time,sep = ""),"\n")
   cat(paste("   ","Consensus method:         ","Weighted average",sep = ""),"\n")
   cat(paste("   ","Weight:                   ","AUC",sep = ""),"\n")
   cat(paste("   ","Percentage of Consensus:  ",Perc," %",sep = ""),"\n")

   List = list()
   List[[1]] = Espece ; names(List)[1] = "Species"
   List[[2]] = Time ; names(List)[2] = "Time"
   List[[3]] = "Weighted average" ; names(List)[3] = "Consensus method"
   List[[4]] = "AUC" ; names(List)[4] = "Weight"
   List[[5]] = paste(Perc," %",sep = "") ; names(List)[5] = "Percentage of Consensus"

   assign(paste("Info_",Espece,"_",Time,sep = ""),List)
   eval(parse(text = paste("save(Info_",Espece,"_",Time,",file = '",
        getwd(),"/cons.",Time,"/Info_",Espece,"_",Time,"')",sep = "")))
}
#_______________________________________________________________________________

SynthesisBySpecies <- function(Id_Proj,Obs,Espece){

   library(rgdal)

   Dir <- getwd()
   setwd("../..")
   dir.create(paste(getwd(),"/All.Species",sep = ""),showWarnings = F)
   dir.create(paste(getwd(),"/All.Species/ArcGISFiles",sep = ""),showWarnings = F)

   SHP <- readOGR(paste(getwd(),"/Cartes/species_shapefiles",sep = ""),"Example")
   proj4string(SHP) <- CRS("+proj=longlat +ellps=GRS80 +datum=NAD83 +no_defs")
   
   Ordre <- as.data.frame(SHP[["GRID_IDKEY"]])
   colnames(Ordre) <- "Ordre"
   
   res <- merge(Ordre,Obs,by.x = "Ordre",by.y = "Grid_IDKey",all.x = T,all.y = T)
   pos <- which(is.na(res[,2]))
   if (length(pos) > 0){
      res[pos,-1] <- -9999
   }
 
   SHP[["value"]] <- res[,2]
   names(SHP)[length(names(SHP))] <- "value"
 
   writeOGR(SHP,
            paste(getwd(),"/Cartes/species_shapefiles/obs",sep = ""),
            paste(Espece,"-Observed",sep = ""),driver = "ESRI Shapefile")   
 
   setwd(Dir)
   
   Time <- dir()[which(substr(dir(),1,4) == "cons")]
   Time <- substr(Time,6,nchar(Time))
   
   Prefixe <- c("Cons_Proj_","Cons_Proj_","Sd_Proj_")
   Suffixe <- c(".txt","_Bin.txt",".txt")
   Name <- c("Cons","Cons_Bin","Sd")
   Shp.Fold <- c("prob","pres_abs","sd")
   Shp.Name <- c("-prob-","-bin-","-sd-")

   Final <- data.frame(Ordre,res[,2]) ; colnames(Final) = c("Id_Key","Observed")
   
   for (i in 1 : length(Time)){
     
      inter <- as.data.frame(matrix(nrow = nrow(Ordre),ncol = 3))

      for (k in 1 : length(Prefixe)){

         temp <- read.table(paste("cons.",Time[i],"/",Prefixe[k],Time[i],"_",Espece,Suffixe[k],sep = ""),h = T)

         if (Name[k] == "Cons" || Name[k] == "Sd"){            
            temp <- as.data.frame(cbind(Id_Proj,temp/1000))
            colnames(temp)[1] <- "Grid_IDKey"
         }else{
            temp <- as.data.frame(cbind(Id_Proj,temp))
            colnames(temp)[1] <- "Grid_IDKey"
         }
         res <- merge(Ordre,temp,by.x = "Ordre",by.y = "Grid_IDKey",all.x = T,all.y = T)

         pos <- which(is.na(res[,"Total"]))
         if (length(pos) > 0){
            res[pos,-1] <- -9999
         }
         res <- res[,-1]

         SHP[["value"]] <- res[,dim(res)[2]]
         names(SHP)[length(names(SHP))] <- "value"
            
         inter[,k] <- res[,dim(res)[2]]
         colnames(inter)[k] <- paste(Name[k],Time[i],sep = "_")                 

         setwd("../..")

         writeOGR(SHP,
                  paste(getwd(),"/Cartes/species_shapefiles/",Shp.Fold[k],sep = ""),
                  paste(Espece,Shp.Name[k],Time[i],sep = ""),driver = "ESRI Shapefile")

         setwd(Dir)
      }
      Final <- as.data.frame(cbind(Final,inter))
   }
   setwd("../..")
   write.table(Final,
               file = paste(getwd(),"/All.Species/ArcGISFiles/ArcGIS_",Espece,".txt",sep = ""),
               col.names = T,
               row.names = F,
               sep = "\t")
   cat(paste("   SynthesisBySpecies (",Espece,") :        Done",sep = ""),"\n")
}

#_______________________________________________________________________________

SynthesisAllSpecies = function(Espece = NULL,Racine = T){

   times = dir()[which(substr(dir(),1,4) == "cons")]
   Time = substr(times,6,nchar(times))
   
   if (Racine == F){
      setwd("..")
      Fold = dir()
      setwd("..")
   }
         
   dir.create(paste(getwd(),"/All.Species/Evaluation",sep = ""),showWarnings = F)
   
   Dir = getwd() #  = R_Outputs
   
   if (is.null(Espece)){
      Espece = dir()
      Espece = Espece[-(which(Espece == "All.Species"))]
      Espece = Espece[-(which(Espece == "Cartes"))]
   }
      
   if (Racine == F){
      Acces = paste(Espece,"/",Fold,sep = "")
   }else{
      Acces = Espece
   }
      
   Id = read.table(paste(Dir,"/All.Species/ArcGISFiles/ArcGIS_",Espece[1],".txt",sep = ""),h = T)
      
   for (j in 1 : length(Time)){
   
      Pred.table = as.data.frame(matrix(NA,nrow = dim(Id)[1],ncol = length(Espece)+1))
      colnames(Pred.table) = c("Id_key",Espece)
      Pred.table[,1] = Id[,1]
      Bin.table = as.data.frame(matrix(NA,nrow = dim(Id)[1],ncol = length(Espece)+1))
      colnames(Bin.table) = c("Id_key",Espece)
      Bin.table[,1] = Id[,1]
      Sd.table = as.data.frame(matrix(NA,nrow = dim(Id)[1],ncol = length(Espece)+1))
      colnames(Sd.table) = c("Id_key",Espece)
      Sd.table[,1] = Id[,1]
      
      for (i in 1 : length(Espece)){
      
         Pred = read.table(paste(Dir,"/All.Species/ArcGISFiles/ArcGIS_",Espece[i],".txt",sep = ""),h = T)
         Pred.table[,i+1] = Pred[,paste("Cons_",Time[j],sep = "")]
         Bin.table[,i+1] = Pred[,paste("Cons_Bin_",Time[j],sep = "")]
         Sd.table[,i+1] = Pred[,paste("Sd_",Time[j],sep = "")]
      }
    
      write.table(Pred.table,file = paste(getwd(),"/All.Species/ArcGISFiles/ArcGIS_Probability_",Time[j],".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
      write.table(Bin.table,file = paste(getwd(),"/All.Species/ArcGISFiles/ArcGIS_Binary_",Time[j],".txt",sep = ""),col.names = T,row.names = F,sep = "\t")
      write.table(Sd.table,file = paste(getwd(),"/All.Species/ArcGISFiles/ArcGIS_Uncertainty_",Time[j],".txt",sep = ""),col.names = T,row.names = F,sep = "\t")}
                     
   cat("   SynthesisAllSpecies :        Done","\n")
}
#===============================================================================

Evaluation.Info <- function(Espece){
  
  R.Out <- getwd()
  dir.create(paste(getwd(),"/All.Species",sep = ""),showWarnings = F)
  dir.create(paste(getwd(),"/All.Species/Evaluation",sep = ""),showWarnings = F)
 
  Roc <- Var <- data.frame()
  for(i in 1 : length(Spp)){
    
    setwd(paste(R.Out,"/",Spp[i],"/1-10",sep = ""))
    load(paste(Spp[i],"_run.Rdata",sep = ""))
    
    # Importance des variables
    imp <- apply(VarImportance[[1]],2,mean)
    names(imp) <- NULL
    imp <- as.data.frame(t(c(Spp[i],imp)))
    names(imp) <- c("Species",colnames(VarImportance[[1]]))
    Var <- as.data.frame(rbind(Var,imp))
    colnames(Var) <- c("Species",colnames(VarImportance[[1]]))
    
    # Performances des modles
    auc <- data.frame()
    for (j in 1 : (length(Evaluation.results.Roc)-1)){
      
      Eval <- Evaluation.results.Roc[[j+1]]
      xx <- t(as.numeric(Eval[,"Cross.validation"]))
      colnames(xx) <- rownames(Eval)
      auc <- as.data.frame(rbind(auc,xx))
      colnames(auc) <- rownames(Eval)
    }
    yy <- as.data.frame(t(c(Spp[i],apply(auc,2,mean),mean(apply(auc,2,mean)))))
    names(yy) <- c("Species",colnames(auc),"Total")
    Roc <- as.data.frame(rbind(Roc,yy))
    names(Roc) <- c("Species",colnames(auc),"Total")
    
  }
  setwd("../..")
  write.table(Roc,
              file = paste(getwd(),"/All.Species/Evaluation/AUC_Results.txt",sep = ""),
              col.names = T,
              row.names = F,
              sep = "\t")
  write.table(Var,
              file = paste(getwd(),"/All.Species/Evaluation/ImpVar_Results.txt",sep = ""),
              col.names = T,
              row.names = F,
              sep = "\t")
  setwd(R.Out)
  cat(paste("   Evaluation.Info:        Done",sep = ""),"\n")
}

